--    ======================
--    Description
--    ======================
--
--    Jeżeli przez określony czas nie zostanie spełniony warunek warunek matematyczny (np. input > setting) to na wyjściu zostaje zwiększana wartość o 1 aż do osiągnięcia maksymalnej
--    dopuszczalnej wartości. Jeżeli warunek zostanie spełniony to na wyjście podawane jest 0.
--
--    ======================
--    Parameters
--    ======================
--
--    SubLogic supports following variables:
--
--    output                                   - wyjście
--
--    counter.main.downcounter                 - licznik który odlicza czas do 0. Jeżeli warunek matematyczny nie jest spełniony i licznik dotrze do 0 to 
--                                               output = output + 1 aż do osiągnięcia setting.output.max.value
--
--    counter.cnt.downcounter                  - poldicznik, po osiągnięciu wartości 0 wartość counter.main.downcounter jest zmniejszana o 1
--
--    setting.param.0
--    setting.param.1
--                                             - parametry dla warunku matematycznego
--
--    setting.time                             - jeżeli przez ten odcinek czasu warunek matematyczny nie zostanie spełniony to output = output + 1 aż do osiągnięcia setting.output.max.value
--
--    setting.output.max.value                 - maksymalna wartość jaką może osiągnąć output
--
--    setting.option                           - w jaki sposób warunek matematyczny jest rozpatrywany:
--                                               0: setting.param.0 >= setting.param.1
--
--    setting.cnt.period                       - okres w sekundach podlicznika do zmniejszania licznika głównego counter.main.downcounter. Np. 
--                                                60 oznacza odliczanie czasu (counter.work_time) w minutach.
--                                                3600 oznacza odliczanie czasu w godzinach.
--
--    Logic uses lua language to implement own behaviour
--
--    ======================
--    mandatory variables
--    ======================
--
--    Logic expects following mandatory variables:
--
--    reload.trigger                          - causes reloading lua script
--
--    memcnt                                  - current amount of memory used by lua in bytes
--
--    Logic expects following kv settings:
--
--    LuaScriptPath                           - path to the lua script - must be absolute
--
--    ======================
--    ChangeLog
--    ======================
--
--    2018-10-18 ver 0.0.0
--
--    + First release
--
-- user can use some functions provided by ibmanager.

-- ibmanager provides following functions to use:
--
-- function returns value of required ibmanager variable
-- @param fullName - string - variable name - name of variable of which value must be returned, for example "rs.0.id.255.input.t.0.value"
-- @return         - string or integer - variable value or "nil" if variable not exist or is not readable
--
-- getValue(fullName)


-- function set value of given ibmanager variable
-- @param fullName - string - variable name - name of variable of which value we want to set, for example "rs.0.id.255.input.t.0.value"
-- @param value    - string, int or boolean - value to set
-- @return         - nothing
--
-- setValue(fullName, value)


-- function returns value of required ibmanager variable
-- @param key      - placed in xml logic configuration file:
--                   * as attribute: Name, in Var, RemoteVar and ImportVar elements in the case of stand alone variables
--                   * as concatenation of two attributes: ListName.Postfix in VarListItem, RemoteVarListItem and ImportVarListItem elements
--                     in the case of variables that are placed in lists
-- @return         - string or integer - variable value or "nil" if variable not exist or is not readable
--
-- getLogicValue(key)


-- function set value of given ibmanager variable
-- @param key      - placed in xml logic configuration file:
--                   * as attribute: Name, in Var, RemoteVar and ImportVar elements in the case of stand alone variables
--                   * as concatenation of two attributes: ListName.Postfix in VarListItem, RemoteVarListItem and ImportVarListItem elements
--                     in the case of variables that are placed in lists
-- @param value    - string, int or boolean - value to set
-- @return         - nothing
--
-- setLogicValue(key, value)

-- function returns two sections of kvsettings from xml configuration file
-- returned value is two element table, each of these elements is table too.
-- indices of returned table are strings and equal "instance" and "global"
-- values of returned tables are tables and contain KVsettings for applicable section.
-- nested tables have form key = value, where key is index in nested table and value is value.
-- example: {"instance" = {"ikey1" = "ivalue1", "ikey2" = "gvalue2"}, "global" = {"gkey1" = "gvalue1", "gkey2" = "gvalue2", "gkey3" = "gvalue3"}}
-- @return          - two dimensional array - kvsettings for global and instance sections
-- getKvSettings()


-- function schedules alert to send.
-- rules are defined in separated alert configuration files and are described in ibmanager instruction manual
-- @param id - alert identifier - must be defined in current logic configuration file in section: <Alert Id="any_identifier" ...
-- scheduleAlert(id)

-- function cancels alert sending, if was previously scheduled. if not then only wakes up alerts handling thread, so if there is no need to call this function, then do not call it.
-- rules are defined in separated alert configuration files and are described in ibmanager instruction manual
-- @param id - alert identifier - must be defined in current logic configuration file in section: <Alert Id="any_identifier" ...
-- cancelAlert(name)

-- function returns table, containing Variables that belongs to required list.
-- @param listName - Name attribute of VarList, RemoteVarList or ImportVarList elemetnst in configurationfile
-- @return array of key-value pairs. Key - variable postfix, Value - Variable value
-- getVarList(listName)

-- function returns monotonic system clock value, that elapsed since specific epoch
-- returned time is expressed in milliseconds.
-- getClock()

-- function logs message to file, if defined in configuration file log level is less than passed to this function
-- @param logLevel - one of:
--        LogLevel.TraceLo
--        LogLevel.Trace
--        LogLevel.TraceHi
--        LogLevel.DebugLo
--        LogLevel.Debug
--        LogLevel.DebugHi
--        LogLevel.Info
--        LogLevel.Notice
--        LogLevel.Warning
--        LogLevel.Error
--        LogLevel.Critical
-- @param logMessage - string to log
-- log(logLevel, logMessage)


-- ibmanager provides following global variables:

-- logic type, (in this case it will always be "Lua") - the same as in logic configuration file in section: <Logic Type="Lua" ...
-- LOGIC_TYPE

-- logic version, the same as in logic configuration file in section: <Logic ... Version="x.y.z" ...
-- LOGIC_VERSION

-- logic sub-type, the same as in logic configuration file in section: <Logic ... SubType="Hysteresis" ...
-- LOGIC_SUBTYPE

-- logic sub-version, the same as in logic configuration file in section: <Logic ... SubVersion="x.y.z" ...
-- LOGIC_SUBVERSION

-- logic instance name - the same as in logic configuration file, in section: <Instance Name="0">
-- LOGIC_INSTANCE_NAME

-- add script directory to package path
package.path = package.path .. ";./logic/scripts/utils/?.lua";

-- use script - without .lua extension - delta class
require("State");
require("DownCounter");

g_output = nil;
g_counterCntDowncounter = nil;
g_counterMainDowncounter = 0;

SUPPORTED_SUBLOGIC_TYPE = "MathTime";
SUPPORTED_SUBLOGIC_VERSION = "0.0.0";
g_versionChecked = false;

-- entry point to the logic
-- @param firstCall - tells if logic is called first time
-- @return        - nothing
function onLogicCall(firstCall)

  if not g_versionChecked then
    -- checking sublogic type and sublogic version
    if LOGIC_SUBTYPE ~= SUPPORTED_SUBLOGIC_TYPE then
      error("Wrong logic sub-type. expected " .. SUPPORTED_SUBLOGIC_TYPE .. " but used " .. LOGIC_SUBTYPE);
    end
    local versionWithoutBuild = string.match(LOGIC_SUBVERSION, "[0-9]+%.[0-9]+%.[0-9]+");
    if versionWithoutBuild ~= SUPPORTED_SUBLOGIC_VERSION then
      error("Wrong logic sub-version. expected " .. SUPPORTED_SUBLOGIC_VERSION .. " but used " .. LOGIC_SUBVERSION);
    end
    g_versionChecked = true;
  end

  local settingParam0 = getLogicValue("setting.param.0");
  local settingParam1 = getLogicValue("setting.param.1");
  local settingTime = getLogicValue("setting.time");
  local settingOutputMaxValue = getLogicValue("setting.output.max.value");
  local settingOption = getLogicValue("setting.option");
  local settingCntPeriod = getLogicValue("setting.cnt.period");
  
  local counterCntDowncounter = 0;
  
-- states
  if g_output == nil or firstCall then
    g_output = State.create(0, 0, settingOutputMaxValue, true);
  end
    
  g_output:setMax(settingOutputMaxValue);
  g_output:call();

  -- timers
  if g_counterCntDowncounter == nil or firstCall then
    g_counterCntDowncounter = DownCounter.create();
  end
  g_counterCntDowncounter:updateParams(settingCntPeriod * 1000);

  counterCntDowncounter = g_counterCntDowncounter:timeTo0() / 1000;
  counterCntDowncounter = (counterCntDowncounter < 0) and 0 or counterCntDowncounter;
  
  if firstCall then
    g_counterMainDowncounter = settingTime;
  end

  if settingOption == 0 then
    -- setting.param.0 >= setting.param.1
    if (settingParam0 >= settingParam1) then
      g_counterMainDowncounter = settingTime;
      g_counterCntDowncounter:reset();
      g_output:setValue(0);
    end
  else
    g_output:setValue(0);
  end
  
  if g_counterCntDowncounter:elapsed() then
    if g_counterMainDowncounter > 0 then
      g_counterMainDowncounter = g_counterMainDowncounter - 1;
    end

    if g_counterMainDowncounter == 0 then
      g_output:setValue(g_output:getValue() + 1);
      g_counterMainDowncounter = settingTime;
    end
    
    g_counterCntDowncounter:reset();
  end

  -- send logic variables to ibmanager
  setLogicValue("output", g_output:getValue());
  setLogicValue("counter.main.downcounter", g_counterMainDowncounter);
  setLogicValue("counter.cnt.downcounter", counterCntDowncounter);
  

end
